﻿using System.Windows;
using Infragistics.Windows.DataPresenter;



namespace SSI.Windows.InfragisticsExtensions
{
	/// <summary>
	/// Extensions
	/// </summary>
	public class XamDataPresenterExtensions
	{
		#region FieldAdornerSettings Property
		/// <summary>
		/// Field Adorner Settings Dependency Property
		/// </summary>
		public static readonly DependencyProperty FieldAdornerSettingsProperty = DependencyProperty.RegisterAttached("FieldAdornerSettings", typeof(FieldAdornerSettings), typeof(XamDataPresenterExtensions), new UIPropertyMetadata(null, OnFieldAdornerSettingsChanged));

		/// <summary>
		/// Gets the FieldAdornerSettings object
		/// </summary>
		/// <param name="target"></param>
		/// <returns></returns>
		public static FieldAdornerSettings GetFieldAdornerSettings (DependencyObject target)
		{
			return ((FieldAdornerSettings) target.GetValue(FieldAdornerSettingsProperty));
		}

		/// <summary>
		/// Sets the FieldAdornerSettings object
		/// </summary>
		/// <param name="target"></param>
		/// <param name="value"></param>
		public static void SetFieldAdornerSettings (DependencyObject target, FieldAdornerSettings value)
		{
			target.SetValue(FieldAdornerSettingsProperty, value);
		}

		private static void OnFieldAdornerSettingsChanged (DependencyObject o, DependencyPropertyChangedEventArgs e)
		{
			OnFieldAdornerSettingsChanged((DataPresenterBase) o, (FieldAdornerSettings) e.OldValue, (FieldAdornerSettings) e.NewValue);
		}

		private static void OnFieldAdornerSettingsChanged (DataPresenterBase presenter, FieldAdornerSettings oldvalue, FieldAdornerSettings newvalue)
		{
			oldvalue?.Detach();
			newvalue?.Attach(presenter);
		}
		#endregion
	}
}