﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Dynamic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Threading;
using Infragistics.Controls.Grids;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows.Editors;
using SSI.Application;
using SSI.Data.Conjoint;
using SSI.Windows.Application;
using SSI.Windows.InfragisticsExtensions;



namespace SSI.Windows.Simulation.Conjoint
{
	public partial class AttributeLevelCellAdorner : XamDataPresenterFieldAdorner
	{
		#region Level Info Item
		public class LevelInfoItem
		{
			public String Label { get; set; }
			public String Value { get; set; }
		}
		#endregion

		#region Construction
		public AttributeLevelCellAdorner ()
		{
			InitializeComponent();

			if (DesignerProperties.GetIsInDesignMode(this))
				return;
			this.timer = new System.Timers.Timer(100);
			this.timer.Elapsed += (Object sender, System.Timers.ElapsedEventArgs e) =>
			{
				this.Dispatcher.Invoke(() =>
				{
					try
					{
						this.UpdateDynamicElements();
					}
					finally
					{
					}
				});
			};
		}
		#endregion

		private System.Timers.Timer timer = null;
		private Boolean matchtolabel = true;
		/// <summary>
		/// This value will be set to true when a user uses the up and down arrows within the editor; we use that as a signal to choose the focused level when the Enter or Tab key is pressed.
		/// This works only on continuous variables to compensate for the fact that it should not autocomplete if they type a value and press Enter or Tab without selecting a value
		/// </summary>
		private Boolean manualselection = false;

		private ObservableCollection<LevelInfoItem> levellist = new ObservableCollection<LevelInfoItem>();

		private Boolean iscontinuous = false;

		private Boolean somethinghappened = false;

		public void Initialize (IAttributeInfo attinfo, Int32 attidx)
		{
			this.iscontinuous = attinfo.GetAttributeVariableType(attidx) == Data.VariableDataType.Continuous;

			for (Int32 l = 0; l < attinfo.GetAttributeLevelCount(attidx); ++l)
			{
				this.levellist.Add(new LevelInfoItem() { Label = attinfo.GetAttributeLevelLabel(attidx, l), Value = attinfo.GetAttributeLevelValue(attidx, l).ToString(SimulatorApp.AppSettings.CurrentCulture) });
			}

			this.staticgrid.ItemsSource = this.levellist;
		}

		private Boolean initializekeyhighlight = true;
        public Boolean ProcessKeyStroke(Key key)
        {
            this.somethinghappened = true;

            if (key == Key.Down || key == Key.Up)
            {
                if (this.staticgrid.SelectionSettings.SelectedRows != null)
                {
                    if (this.staticgrid.SelectionSettings.SelectedRows.Count == 0)
                    {
                        this.staticgrid.SelectionSettings.SelectedRows.Add(this.staticgrid.Rows[0]);
                    }
                    else
                    {
                        int index = this.staticgrid.SelectionSettings.SelectedRows[0].Index;

                        if (key == Key.Down)
                        {
                            if (!((index + 1) > this.staticgrid.Rows.Count - 1))
                            {
                                this.staticgrid.SelectionSettings.SelectedRows.Clear();
                                this.staticgrid.SelectionSettings.SelectedRows.Add(this.staticgrid.Rows[index + 1]);
                            }
                        }
                        else
                        {
                            if (!((index - 1) < 0))
                            {
                                this.staticgrid.SelectionSettings.SelectedRows.Clear();
                                this.staticgrid.SelectionSettings.SelectedRows.Add(this.staticgrid.Rows[index - 1]);
                            }
                        }
                    }
                }
                //if (this.initializekeyhighlight)
                //            {
                //                this.staticgrid.Focus();
                //                this.initializekeyhighlight = false;
                //                var args = new KeyEventArgs(Keyboard.PrimaryDevice, PresentationSource.FromVisual(this.staticgrid), 0, Key.Down) { RoutedEvent = Keyboard.KeyDownEvent };
                //                this.staticgrid.RaiseEvent(args); // send it to the grid
                //                args = new KeyEventArgs(Keyboard.PrimaryDevice, PresentationSource.FromVisual(this.staticgrid), 0, Key.Up) { RoutedEvent = Keyboard.KeyDownEvent };
                //                this.staticgrid.RaiseEvent(args); // send it to the grid
                //            }
                //else
                //{
                //                var args = new KeyEventArgs(Keyboard.PrimaryDevice, PresentationSource.FromVisual(this.staticgrid), 0, key) { RoutedEvent = Keyboard.KeyDownEvent };
                //                this.staticgrid.RaiseEvent(args); // send it to the grid
                //            }

            }     

            if(key == Key.Enter)
            {
                //Push value to grid cell...unsure how this is being done at the moment... -ANDREW
            }

            return (false);
		}

		private void OnLoaded (Object sender, RoutedEventArgs e)
		{
			this.matchtolabel = SimulatorApp.AppSettings.UseLabelMatching();
			this.dynamicgridheader.Visibility = Visibility.Collapsed;
			this.dynamicgridheadernomatches.Visibility = Visibility.Collapsed;
			this.dynamicgrid.Visibility = Visibility.Collapsed;
			this.timer.Start();
			this.somethinghappened = true;
		}

		private void OnUnloaded (Object sender, RoutedEventArgs e)
		{
			this.timer.Stop();
		}

		private void UpdateDynamicElements ()
		{
			if (this.AdornedCell == null || !this.somethinghappened)
				return;

			var cell = this.AdornedCell;
			var celleditor = CellValuePresenter.FromCell(cell).Editor;
			String partialtext = celleditor.Text;

			try
			{
				if (!String.IsNullOrWhiteSpace(partialtext))
				{
					var valuemappings = this.levellist.ToDictionary(k => k.Label, v => System.Convert.ToDouble(v.Value, SimulatorApp.AppSettings.CurrentCulture));
					var result = FormulaHelpers.GetHelperHighlighting(FormulaHelpers.HelperTexts, partialtext, FormulaHelpers.NoMatchText, valuemappings, SimulatorApp.AppSettings.CurrentCulture);
					Trace.WriteLine(String.Format("highlighting <{0}>,<{1}>,<{2}>", result[0] ?? "null", result[1] ?? "null", result[2] ?? "null"));

					this.prefunctiontextblock.Text = result[0];
					this.prefunctiontextblock.Visibility = result[0] != null ? Visibility.Visible : Visibility.Collapsed;

					this.highlightfunctiontextblock.Text = result[1];
					this.highlightfunctiontextblock.Visibility = result[1] != null ? Visibility.Visible : Visibility.Collapsed;

					this.postfunctiontextblock.Text = result[2];
					this.postfunctiontextblock.Visibility = result[2] != null ? Visibility.Visible : Visibility.Collapsed;

					this.functionwrappanel.Visibility = result.Any(x => x != null) ? Visibility.Visible : Visibility.Collapsed;
				}
				else
					this.functionwrappanel.Visibility = Visibility.Collapsed;
			}
			catch
			{
				this.functionwrappanel.Visibility = Visibility.Collapsed;
			}


			Visibility visheader = Visibility.Collapsed;
			Visibility visgrid = Visibility.Collapsed;
			Visibility visnomatch = Visibility.Collapsed;

			if (!this.manualselection && this.matchtolabel)
			{
				if (!String.IsNullOrWhiteSpace(partialtext))
				{
					var list = this.levellist;
					var matches = list?.Where(x => !String.IsNullOrWhiteSpace(x.Label) && x.Label.Contains(partialtext, StringComparison.InvariantCultureIgnoreCase));
					if (matches != null && matches.Count() > 0)
					{
						this.dynamicgrid.ItemsSource = matches;
						visheader = Visibility.Visible;
						visgrid = Visibility.Visible;
					}
					else if (matches != null && matches.Count() == 0)
					{
						visheader = Visibility.Visible;
						visnomatch = Visibility.Visible;
					}
				}
			}

			this.dynamicgridheader.Visibility = visheader;
			this.dynamicgrid.Visibility = visgrid;
			this.dynamicgridheadernomatches.Visibility = visnomatch;

			this.somethinghappened = false;
		}

		private void OnCellClicked (Object sender, Infragistics.Controls.Grids.CellClickedEventArgs e)
		{
			this.SelectActiveItem(sender as XamGrid);
		}

		private void SelectActiveItem (XamGrid xamgrid)
		{
			var item = xamgrid.ActiveItem as LevelInfoItem;
			String text = null;
			if (this.matchtolabel && !this.iscontinuous)
				text = item.Label ?? item.Value; // theoretically we shouldn't need the null condition here, but it provides safety
			else
				text = item.Value ?? item.Label;

			this.SetValueAndClose(text);
		}

		private void SetValueAndClose (String text)
		{
			DataPresenterBase datapresenter = this.AdornedCell.DataPresenter;
			Action action = () =>
			{
				datapresenter.ExecuteCommand(DataPresenterCommands.EndEditModeAndCommitRecord);
				if (datapresenter.ActiveRecord.IsSpecialRecord)
					datapresenter.RecordManager.CommitAddRecord();
			};

			this.SetValueAndClose(text, action);
		}

		private void SetValueAndClose (String text, Action closeaction)
		{
			DataPresenterBase datapresenter = this.AdornedCell.DataPresenter;

			if (this.AdornedCell.Value == null || text != (String) this.AdornedCell.Value)
			{
				this.AdornedCell.Value = text;
				this.Dispatcher.Invoke(closeaction);
			}
			else if (text == (String) this.AdornedCell.Value)
			{
				this.Dispatcher.Invoke(() =>
				{
					datapresenter.ExecuteCommand(DataPresenterCommands.EndEditModeAndDiscardChanges);
				});
			}

			this.Close();
		}
	}

	public class AttributeLevelCellAdornerBehavior : Behavior<XamDataGrid>
	{
		#region Attribute Info Dependency Property
		public static readonly DependencyProperty AttributeInfoProperty = DependencyProperty.Register("AttributeInfo", typeof(IAttributeInfo), typeof(AttributeLevelCellAdornerBehavior));
		public IAttributeInfo AttributeInfo
		{
			get
			{
				return ((IAttributeInfo) this.GetValue(AttributeInfoProperty));
			}
			set
			{
				this.SetValue(AttributeInfoProperty, value);
			}
		}
		#endregion

		#region Has Label Column Dependency Property
		/// <summary>
		/// Gets or sets whether the grid has a label column
		/// </summary>
		public static readonly DependencyProperty HasLabelColumnProperty = DependencyProperty.Register("HasLabelColumn", typeof(Boolean), typeof(AttributeLevelCellAdornerBehavior), new FrameworkPropertyMetadata(true));

		/// <summary>
		/// Gets or sets whether the grid has a label column
		/// </summary>
		public Boolean HasLabelColumn
		{
			get
			{
				return ((Boolean) this.GetValue(HasLabelColumnProperty));
			}
			set
			{
				this.SetValue(HasLabelColumnProperty, value);
			}
		}
		#endregion

		#region Label Column Key Dependency Property
		/// <summary>
		/// Gets or sets the internal label of the label column
		/// </summary>
		public static readonly DependencyProperty LabelColumnKeyProperty = DependencyProperty.Register("LabelColumnKey", typeof(String), typeof(AttributeLevelCellAdornerBehavior), new PropertyMetadata("LABEL@INTERNAL"));

		/// <summary>
		/// Gets or sets the internal label of the label column
		/// </summary>
		public String LabelColumnKey
		{
			get
			{
				return ((String) this.GetValue(LabelColumnKeyProperty));
			}
			set
			{
				this.SetValue(LabelColumnKeyProperty, value);
			}
		}
		#endregion

		#region Adorner Property
		private UIElementAdorner<Control> Adorner { get; set; } = null;

		/// <summary>
		/// Gets whether the adorner is visible
		/// </summary>
		protected Boolean IsAdornerVisible
		{
			get
			{
				return (this.Adorner.Visibility == Visibility.Visible);
			}
		}
		#endregion

		#region Behavior
		protected override void OnAttached ()
		{
			base.OnAttached();
			this.Adorner = new UIElementAdorner<Control>(this.AssociatedObject);
			this.HookEventHandlers();
			this.AssociatedObject.FieldLayoutInitialized += this.FieldLayoutInitialized;
			//base.AssociatedObject.DataSourceChanged += this.DataSourceChanged;
			//base.AssociatedObject.PreviewKeyDown += this.PreviewKeyDown;
		}

		protected override void OnDetaching ()
		{
			base.OnDetaching();
			this.Adorner = null;
			this.UnhookEventHandlers();
			this.AssociatedObject.FieldLayoutInitialized -= this.FieldLayoutInitialized;
			//base.AssociatedObject.DataSourceChanged -= this.DataSourceChanged;
			//base.AssociatedObject.PreviewKeyDown -= this.PreviewKeyDown;
		}

		private void FieldLayoutInitialized (Object sender, FieldLayoutInitializedEventArgs e)
		{
			var grid = sender as XamDataGrid;
			if (grid == null || grid.DataSource == null)
				return;

			List<String> names = null;
			Boolean isprohibitions = false;

			var datasource = grid.DataSource;
			if (datasource is DynamicDictionaryCollection)
			{
				var coll = datasource as DynamicDictionaryCollection;
				if (coll.ItemTemplate != null)
					names = coll.ItemTemplate.GetDynamicMemberNames().ToList();
				else if (coll.Count() > 0)
					names = coll.First().GetDynamicMemberNames().ToList();
			}
			else
			{
				if (grid.DataSource.Cast<Object>().FirstOrDefault() is DynamicObject first)
					names = first.GetDynamicMemberNames().ToList();
			}

			if (names == null)
				return;

			e.FieldLayout.Fields.Clear();
			foreach (String name in names)
			{
				if (name == "Selected")
					continue;
				if (isprohibitions)
				{
					if (name == "IsFirst" || name == "IsLast" || name == "GroupColor")
						continue;
				}

				Field field = null;

				if (this.HasLabelColumn && name == this.LabelColumnKey)
				{
					field = new Field
					{
						Name = name,
						Label = "Label",
						BindingType = BindingType.UseAlternateBinding,
						AlternateBinding = new Binding(String.Format("[{0}]", name.Replace("^", "^^").Replace(",", "^,"))) { Mode = BindingMode.TwoWay },
						DataType = typeof(String)
					};

					var trigger = new MultiDataTrigger();
					trigger.Conditions.Add(new Condition(new Binding() { RelativeSource = new RelativeSource(RelativeSourceMode.Self), Path = new PropertyPath("Text") }, ""));
					trigger.Conditions.Add(new Condition(new Binding() { RelativeSource = new RelativeSource(RelativeSourceMode.FindAncestor, typeof(DataRecordPresenter), 1), Path = new PropertyPath("IsAddRecord") }, true));
					trigger.Setters.Add(new Setter(XamTextEditor.NullTextProperty, "<type a label>"));
					trigger.Setters.Add(new Setter(XamTextEditor.FontStyleProperty, FontStyles.Italic));
					trigger.Setters.Add(new Setter(XamTextEditor.OpacityProperty, 0.3));
					var editorstyle = new Style(typeof(XamTextEditor), global::Infragistics.Windows.Themes.EditorsOffice2013.XamTextEditor);
					editorstyle.Triggers.Add(trigger);
					field.EditorStyle = editorstyle;
				}
				else
				{
					field = new Field
					{
						Name = name,
						Label = name,
						BindingType = BindingType.UseAlternateBinding,
						AlternateBinding = new Binding(String.Format("[{0}]", name.Replace("^", "^^").Replace(",", "^,"))) { Mode = BindingMode.TwoWay },
						DataType = typeof(String)
					};
				}

				field.Settings.CellClickAction = CellClickAction.SelectCell;
				field.Width = new FieldLength(1, FieldLengthUnitType.Auto);

				e.FieldLayout.Fields.Add(field);
			}

			e.Handled = true; // we took care of this
		}

		//private void DataSourceChanged (Object sender, EventArgs e)
		//{
		//	var grid = sender as XamDataGrid;
		//	if (grid == null || grid.DefaultFieldLayout == null)
		//		return;

		//	grid.DefaultFieldLayout.Fields.Clear();
		//}

		//// We listen to this event so that:
		////   We can initiate edit mode on the cell; the grid won't do this by itself
		////   Cache the key pressed because the grid will not forward the key to the editor
		//private void PreviewKeyDown (Object sender, KeyEventArgs e)
		//{
		//	if (Keyboard.Modifiers.HasFlag(ModifierKeys.Control) | Keyboard.Modifiers.HasFlag(ModifierKeys.Alt) | Keyboard.Modifiers.HasFlag(ModifierKeys.Windows))
		//		return;

		//	XamDataGrid grid = sender as XamDataGrid;
		//	if (grid.ActiveCell == null)
		//		return;

		//	if (grid.ActiveCell.IsInEditMode)
		//	{
		//		// We only need to do this for the new row and the label column; the rest are handled elsewhere
		//		if (!grid.ActiveRecord.IsSpecialRecord)
		//			return;
		//		if (grid.ActiveCell.Field.Name != this.LabelColumnKey)
		//			return;

		//		switch (e.Key)
		//		{
		//			case (Key.Tab):
		//				{
		//					e.Handled = true;

		//					Action action = () =>
		//					{
		//						grid.ExecuteCommand(DataPresenterCommands.EndEditModeAndCommitRecord);
		//						grid.ExecuteCommand(DataPresenterCommands.CellNextByTab);
		//					};
		//					this.Dispatcher.Invoke(action);
		//				}
		//				break;

		//			case (Key.Enter):
		//				{
		//					e.Handled = true;

		//					Action action = () =>
		//					{
		//						grid.ExecuteCommand(DataPresenterCommands.EndEditModeAndCommitRecord);
		//						grid.ExecuteCommand(DataPresenterCommands.CellBelow);
		//					};
		//					this.Dispatcher.Invoke(action);
		//				}
		//				break;

		//			case (Key.Escape):
		//				{
		//					e.Handled = true;

		//					Action action = () =>
		//					{
		//						grid.ExecuteCommand(DataPresenterCommands.EndEditModeAndDiscardChanges);
		//					};
		//					this.Dispatcher.Invoke(action);
		//				}
		//				break;

		//			default:
		//				break;
		//		}
		//	}
		//	else
		//	{
		//		switch (e.Key)
		//		{
		//			case (Key.OemPeriod):
		//			case (Key.Space):
		//			case (Key.Subtract):
		//			case (Key.OemMinus):
		//			case (Key.Decimal):
		//			case (Key.A):
		//			case (Key.B):
		//			case (Key.C):
		//			case (Key.D):
		//			case (Key.E):
		//			case (Key.F):
		//			case (Key.G):
		//			case (Key.H):
		//			case (Key.I):
		//			case (Key.J):
		//			case (Key.K):
		//			case (Key.L):
		//			case (Key.M):
		//			case (Key.N):
		//			case (Key.O):
		//			case (Key.P):
		//			case (Key.Q):
		//			case (Key.R):
		//			case (Key.S):
		//			case (Key.T):
		//			case (Key.U):
		//			case (Key.V):
		//			case (Key.W):
		//			case (Key.X):
		//			case (Key.Y):
		//			case (Key.Z):
		//			case (Key.D0):
		//			case (Key.D1):
		//			case (Key.D2):
		//			case (Key.D3):
		//			case (Key.D4):
		//			case (Key.D5):
		//			case (Key.D6):
		//			case (Key.D7):
		//			case (Key.D8):
		//			case (Key.D9):
		//			case (Key.NumPad0):
		//			case (Key.NumPad1):
		//			case (Key.NumPad2):
		//			case (Key.NumPad3):
		//			case (Key.NumPad4):
		//			case (Key.NumPad5):
		//			case (Key.NumPad6):
		//			case (Key.NumPad7):
		//			case (Key.NumPad8):
		//			case (Key.NumPad9):
		//				{
		//					this.PreviewKey = e.Key.AsString();
		//					Action action = () =>
		//					{
		//						grid.ExecuteCommand(DataPresenterCommands.StartEditMode);
		//					};
		//					//this.Dispatcher.BeginInvoke(action, DispatcherPriority.Background);
		//					this.Dispatcher.Invoke(action);
		//				}
		//				break;

		//			case (Key.OemPlus): // with the shift key this is '='
		//				{
		//					if (e.IsToggled) // this shift key
		//					{
		//						this.PreviewKey = e.Key.AsString();
		//						Action action = () =>
		//						{
		//							grid.ExecuteCommand(DataPresenterCommands.StartEditMode);
		//						};
		//						//this.Dispatcher.BeginInvoke(action, DispatcherPriority.Background);
		//						this.Dispatcher.Invoke(action);
		//					}
		//				}
		//				break;

		//			default:
		//				break;
		//		}
		//	}
		//}
		#endregion

		#region Adorner Events and Helpers
		private void HookEventHandlers ()
		{
			this.AssociatedObject.CellChanged += this.CellChanged;
			this.AssociatedObject.CellActivated += this.CellActivated;
			//this.AssociatedObject.EditModeEnded += this.EditModeEnded;
			this.AssociatedObject.EditModeStarted += this.EditModeStarted;
			this.AssociatedObject.GroupByArea.Collapsed += this.GroupByAreaExpansionStateChanged;
			this.AssociatedObject.GroupByArea.Expanded += this.GroupByAreaExpansionStateChanged;
			this.AssociatedObject.Grouped += this.Grouped;
			this.AssociatedObject.IsKeyboardFocusWithinChanged += this.IsKeyboardFocusWithinChanged;
			this.AssociatedObject.PreviewKeyDown += this.PreviewKeyDown;
			this.AssociatedObject.RecordActivated += this.RecordActivated;
			this.AssociatedObject.RecordAdded += this.RecordAdded;
			this.AssociatedObject.RecordCollapsed += this.RecordCollapsed;
			this.AssociatedObject.RecordExpanded += this.RecordExpanded;
			this.AssociatedObject.RecordsInViewChanged += this.RecordsInViewChanged;
			this.AssociatedObject.SizeChanged += this.SizeChanged;
			this.AssociatedObject.Sorted += this.Sorted;
		}

		private void UnhookEventHandlers ()
		{
			this.AssociatedObject.CellChanged -= this.CellChanged;
			this.AssociatedObject.CellActivated -= this.CellActivated;
			//this.AssociatedObject.EditModeEnded -= this.EditModeEnded;
			this.AssociatedObject.EditModeStarted -= this.EditModeStarted;
			this.AssociatedObject.GroupByArea.Collapsed -= this.GroupByAreaExpansionStateChanged;
			this.AssociatedObject.GroupByArea.Expanded -= this.GroupByAreaExpansionStateChanged;
			this.AssociatedObject.Grouped -= this.Grouped;
			this.AssociatedObject.IsKeyboardFocusWithinChanged -= this.IsKeyboardFocusWithinChanged;
			this.AssociatedObject.PreviewKeyDown -= this.PreviewKeyDown;
			this.AssociatedObject.RecordActivated -= this.RecordActivated;
			this.AssociatedObject.RecordAdded -= this.RecordAdded;
			this.AssociatedObject.RecordCollapsed -= this.RecordCollapsed;
			this.AssociatedObject.RecordExpanded -= this.RecordExpanded;
			this.AssociatedObject.RecordsInViewChanged -= this.RecordsInViewChanged;
			this.AssociatedObject.SizeChanged -= this.SizeChanged;
			this.AssociatedObject.Sorted -= this.Sorted;
		}

		// This method is invoked when the value of a cell is modified.
		private void CellChanged (Object sender, CellChangedEventArgs e)
		{
			this.VerifyAdorner();
		}

		private void CellActivated (Object sender, CellActivatedEventArgs e)
		{
			this.VerifyAdorner();
		}

		//private void EditModeEnded (Object sender, EditModeEndedEventArgs e)
		//{
		//	this.VerifyAdorner();
		//}

		private void EditModeStarted (Object sender, EditModeStartedEventArgs e)
		{
			this.VerifyAdorner();
		}

		private void GroupByAreaExpansionStateChanged (Object sender, RoutedEventArgs e)
		{
			this.MoveAdornerWhileGroupByAreaExpansionStateChanges();
		}

		private void Grouped (Object sender, GroupedEventArgs e)
		{
			this.VerifyAdornerAsync();
		}

		private void IsKeyboardFocusWithinChanged (Object sender, DependencyPropertyChangedEventArgs e)
		{
			// This is necessary for when the grid loses focus, and then 
			// gets focus back again.  We need to see if the adorning
			// editor should be displayed for the active cell.
			if (this.AssociatedObject.IsKeyboardFocusWithin && this.AssociatedObject.ActiveCell != null && Keyboard.FocusedElement == this.AssociatedObject)
				this.VerifyAdorner();
		}

		private void PreviewKeyDown (Object sender, KeyEventArgs e)
		{
			e.Handled = this.ProcessKeyStroke(e.Key, e.KeyboardDevice);
		}

		private void RecordActivated (Object sender, RecordActivatedEventArgs e)
		{
			this.VerifyAdorner();
		}

		private void RecordAdded (Object sender, RecordAddedEventArgs e)
		{
			this.VerifyAdornerAsync();
		}

		private void RecordCollapsed (Object sender, RecordCollapsedEventArgs e)
		{
			this.VerifyAdornerAsync();
		}

		private void RecordExpanded (Object sender, RecordExpandedEventArgs e)
		{
			this.VerifyAdornerAsync();
		}

		private void RecordsInViewChanged (Object sender, RecordsInViewChangedEventArgs e)
		{
			this.VerifyAdorner();
		}

		private void SizeChanged (Object sender, SizeChangedEventArgs e)
		{
			this.RelocateAdorner();
		}

		private void Sorted (Object sender, SortedEventArgs e)
		{
			this.AssociatedObject.Dispatcher.BeginInvoke(DispatcherPriority.Background, (Action) (() =>
			{
				if (this.Adorner.Child != null)
					this.RelocateAdorner();
				else
					this.VerifyAdorner();
			}));
		}

		private void HideAdorner ()
		{
			if (this.IsAdornerVisible)
			{
				this.Adorner.Visibility = Visibility.Collapsed;
				this.Adorner.Child = null;
			}
		}

		#region MoveAdornerToActiveCell
		private Boolean MoveAdornerToActiveCell (Control adorningeditor)
		{
			if (this.AssociatedObject.ActiveCell == null)
				return (false);

			if (adorningeditor != null && this.Adorner.Child != adorningeditor)
				this.Adorner.Child = adorningeditor;

			CellValuePresenter cvp = this.GetCellValuePresenterForActiveCell();
			if (cvp != null)
			{
				Point location = this.CalculateAdornerLocation(cvp);
				this.Adorner.SetOffsets(location.X, location.Y);
				return (true);
			}

			return (false);
		}

		private CellValuePresenter GetCellValuePresenterForActiveCell ()
		{
			var activecell = this.AssociatedObject.ActiveCell;
			if (activecell == null)
				return (null);

			CellValuePresenter cvp = CellValuePresenter.FromCell(activecell);
			if (cvp == null || !cvp.IsDescendantOf(this.AssociatedObject) || !cvp.IsVisible)
				return (null);

			return (cvp);
		}

		private Point CalculateAdornerLocation (CellValuePresenter cvp)
		{
			GeneralTransform trans = cvp.TransformToAncestor(this.AssociatedObject);
			Point location = trans.Transform(new Point(0, 0));

			this.VerifyAdornerMetrics();

			IScrollInfo scrollinfo = this.AssociatedObject.ScrollInfo;

			// Make sure the adorner does not extend past the grid's bottom edge.
			Boolean isscrollinghorizontally = scrollinfo.ViewportWidth < scrollinfo.ExtentWidth;
			Double horizontalscrollbarheight = isscrollinghorizontally ? SystemParameters.ScrollHeight : 0;

			Double bottomedgeofadorner = location.Y + cvp.ActualHeight + this.Adorner.ActualHeight;
			if ((this.AssociatedObject.ActualHeight - horizontalscrollbarheight) < bottomedgeofadorner)
				location.Offset(0, -this.Adorner.ActualHeight);
			else
				location.Offset(0, cvp.ActualHeight);

			// Make sure the adorner does not extend past the grid's right edge.
			Boolean isscrollingvertically = scrollinfo.ViewportHeight < scrollinfo.ExtentHeight;
			Double verticalscrollbarwidth = isscrollingvertically ? SystemParameters.ScrollWidth : 0;

			Double rightedgeofadorner = location.X + this.Adorner.ActualWidth;
			Double horizontaldiff = rightedgeofadorner - (this.AssociatedObject.ActualWidth - verticalscrollbarwidth);
			if (0 < horizontaldiff)
				location.Offset(-horizontaldiff, 0);

			return (location);
		}

		private void VerifyAdornerMetrics ()
		{
			this.VerifyAdornerLayer();

			if (!this.IsAdornerVisible)
				this.Adorner.Visibility = Visibility.Visible;

			// Force the adorner through a measure pass since the hosted editor control
			// might have changed since the last time the metrics were calculated.
			this.Adorner.InvalidateMeasure();
			this.Adorner.UpdateLayout();
		}
		#endregion

		private void MoveAdornerWhileGroupByAreaExpansionStateChanges ()
		{
			if (!this.IsAdornerVisible)
				return;

			DispatcherTimer timer = new DispatcherTimer() { Interval = TimeSpan.FromMilliseconds(1) };
			Int32 counter = 0;
			timer.Tick += delegate
			{
				if (++counter > 500)
				{
					timer.Stop();
					timer = null;
				}
				else if (this.IsAdornerVisible)
				{
					this.MoveAdornerToActiveCell(null);
				}
			};
			timer.Start();
		}

		private Boolean ProcessKeyStroke (Key key, KeyboardDevice device)
		{
			if (!this.IsAdornerVisible)
				return (false);

			Boolean handled = false;
			if (key.IsOneOf(Key.Escape, Key.Enter))
			{
				handled = false; // we want this to bubble to the grid to end edit mode, but we're going to hide the adorner
				this.HideAdorner();
			}
			else if (key.IsOneOf(Key.Left, Key.Right))
			{
				handled = false;
			}
			else if (key.IsOneOf(Key.Up, Key.Down))
			{
				handled = true;
				var adorner = this.Adorner.Child as AttributeLevelCellAdorner;
				adorner.ProcessKeyStroke(key);
			}
			//else
			//{
			//	this.GiveFocusToAdorningEditor();
			//	//var adorner = this.Adorner.Child as AttributeLevelCellAdorner;
			//	//handled = adorner.ProcessKeyStroke(key);
			//}

			//if (handled)
			//	this.GiveFocusToAdorningEditor();

			return (handled);
		}

		private void GiveFocusToAdorningEditor ()
		{
			if (this.Adorner.Child == null)// || !this.Adorner.Child.IsTabStop)
				return;

			// Setting focus to the adorner first ensures that the controls
			// inside the editor can receive focus properly.
			FocusManager.SetFocusedElement(this.AssociatedObject, this.Adorner);
			FocusManager.SetFocusedElement(this.AssociatedObject, this.Adorner.Child);
		}

		private void RelocateAdorner ()
		{
			if (this.IsAdornerVisible)
			{
				Boolean resumeediting = false;

				if (this.Adorner.IsKeyboardFocusWithin)
				{
					resumeediting = true;

					// We must take the adorner out of focus otherwise it won't move.
					this.AssociatedObject.Focus();
				}

				// Delay the call that moves the adorner so that the
				// grid has a chance to finish updating its elements.
				this.AssociatedObject.Dispatcher.BeginInvoke(
					DispatcherPriority.Background,
					(Action) delegate
					{
						this.MoveAdornerToActiveCell(null);

						if (resumeediting)
							this.GiveFocusToAdorningEditor();
					});
			}
		}

		private void VerifyAdorner ()
		{
			//if the cell is a filter cell don't do anything with the adorner
			if (this.AssociatedObject.ActiveCell is FilterCell)
				return;

			this.VerifyAdornerLayer();

			AttributeLevelCellAdorner fieldadorner = null;
			if (this.AssociatedObject.ActiveCell != null && this.AssociatedObject.ActiveCell.IsInEditMode)
			{
				String fieldlabel = this.AssociatedObject.ActiveCell.Field.Name;
				if (!this.HasLabelColumn || fieldlabel != this.LabelColumnKey)
				{
					fieldadorner = new AttributeLevelCellAdorner();
					fieldadorner.Attach(this.AssociatedObject);

					Int32 attributeindex = this.AssociatedObject.ActiveCell.Field.Index;
					if (this.HasLabelColumn) // if there is a column label adjust the index
						attributeindex--;
					fieldadorner.Initialize(this.AttributeInfo, attributeindex);
				}
			}

			Boolean movedadorner = false;
			if (fieldadorner != null)
				movedadorner = this.MoveAdornerToActiveCell((Control) fieldadorner);

			if (!movedadorner)
				this.HideAdorner();
		}

		private void VerifyAdornerAsync ()
		{
			this.AssociatedObject.Dispatcher.BeginInvoke(DispatcherPriority.Background, (Action) (() => this.VerifyAdorner()));
		}

		/// <summary>
		/// Ensures that the adorner is in the adorner layer.
		/// </summary>
		/// <returns>True if the adorner is in the adorner layer, else false.</returns>
		private Boolean VerifyAdornerLayer ()
		{
			if (this.Adorner.Parent != null)
				return (true);

			AdornerLayer layer = AdornerLayer.GetAdornerLayer(this.AssociatedObject);
			if (layer == null)
				return (false);

			layer.Add(this.Adorner);
			return (true);
		}
		#endregion
	}
}