﻿using SSI.Data;
using SSI.Data.Conjoint;



namespace SSI.Windows.Simulation.Conjoint
{
	public class AttributeTableModel
	{
		internal static AttributeTable CreateAttributeTable ()
		{
			AttributeTable table = new AttributeTable();

			SSI.Data.Conjoint.Attribute attBrand = new SSI.Data.Conjoint.Attribute("Brand", VariableDataType.Categorical, AttributeRankOrder.None, false);
			attBrand.AddLevel(new AttributeLevel() { Label = "BrandA", Value = 1.0 });
			attBrand.AddLevel(new AttributeLevel() { Label = "BrandB", Value = 2.0 });
			attBrand.AddLevel(new AttributeLevel() { Label = "BrandC", Value = 3.0 });
			table.AddAttribute(attBrand);

			SSI.Data.Conjoint.Attribute attSize = new SSI.Data.Conjoint.Attribute("Size", VariableDataType.Categorical, AttributeRankOrder.WorstToBest, false);
			attSize.AddLevel(new AttributeLevel() { Label = "Small", Value = 1.0 });
			attSize.AddLevel(new AttributeLevel() { Label = "Medium", Value = 2.0 });
			attSize.AddLevel(new AttributeLevel() { Label = "Large", Value = 3.0 });
			table.AddAttribute(attSize);

			SSI.Data.Conjoint.Attribute attPrice = new SSI.Data.Conjoint.Attribute("Price", VariableDataType.Continuous, AttributeRankOrder.BestToWorst, true);
			attPrice.AddLevel(new AttributeLevel() { Label = "Cheap", Value = 1.1 });
			attPrice.AddLevel(new AttributeLevel() { Label = "Average", Value = 2.22 });
			attPrice.AddLevel(new AttributeLevel() { Label = "Expensive", Value = 3.333 });
			table.AddAttribute(attPrice);

			return (table);
		}
	}
}