﻿using System;
using System.Collections.ObjectModel;



namespace XamDataPresenterAdornerFramework
{
	public class ContactEmail
	{
		public String Address { get; set; }

		public ContactEmail (String address)
		{
			this.Address = address;
		}
	}

	public class Contact
	{
		public static Contact[] CreateContacts ()
		{
			return new Contact[]
			{
				/*          Gender  FirstName   LastName      NickName  CellPhone         HomePhone         WorkPhone              PersonalEmail         Notes   */
				new Contact("M",    "Joe",      "Barkley",    "Joey",   "(718) 555 9283", "(718) 555 0012", "(631) 555 9312 x31",  "joey@hotmail.com",   "I owe Joe tickets to the next Giants game.  His wife Joan sells motorcycles and might be able to get me a good deal."),
				new Contact("F",    "Michelle", "Santiago",   "Maggie", "(203) 555 7231", "(203) 555 1321", "(203) 555 1925 x277", "michelle@gmail.com", "Met her at the conference in Panama City back in 2006.  She moved to Los Angeles two years ago, to work in the film industry."),
				new Contact("F",    "Patricia", "McClellan",  "Trish",  "(718) 555 6712", "(718) 555 0190", "(718) 555 4414 x22",  "trish@hotmail.com",  "We met in Las Vegas and discussed a joint venture involving real estate speculation.  She lives in Denver and works in sales."),
				new Contact("M",    "David",    "Esterhazy",  "Dave",   "(617) 555 2212", "(617) 555 8120", "(617) 555 8811 x5",   "david@yahoo.com",    "Dave introduced me to Maggie at the conference in Panama.  He has a lot of contacts in the German banking world."),
				new Contact("M",    "Steven",   "Rottingham", "Steve",  "(201) 555 3449", "(201) 555 9824", "(201) 555 7719 x843", "steve@hotmail.com",  "We worked together on the ProjX system back at AcmeTech in 2004.  He is a big Yankees fan, and is interested in antiques.")
			};
		}

		private Contact (String gender, String firstname, String lastname, String nickname, String cellphone, String homephone, String workphone, String personalemail, String notes)
		{
			this.Gender = gender;
			this.FirstName = firstname;
			this.LastName = lastname;
			this.NickName = nickname;
			this.CellPhone = cellphone;
			this.HomePhone = homephone;
			this.WorkPhone = workphone;
			this.PersonalEmail = personalemail;
			this.Notes = notes;

			this.Emails = new ObservableCollection<ContactEmail>
			{
				new ContactEmail("ProductManager@infragistics.com"),
				new ContactEmail("Sales@infragistics.com"),
				new ContactEmail("Jobs@infragistics.com")
			};
		}

		public String Gender { get; private set; }
		public String FirstName { get; private set; }
		public String LastName { get; private set; }
		public String NickName { get; private set; }

		public String DisplayName
		{
			get
			{
				return (String.Format("{0}, {1}", this.LastName, this.FirstName));
			}
			set
			{
			}
		}

		public String CellPhone { get; set; }
		public String HomePhone { get; private set; }
		public String WorkPhone { get; private set; }

		public String PersonalEmail { get; set; }

		public String Notes { get; set; }

		public ObservableCollection<ContactEmail> Emails { get; set; }
	}
}