﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SSI.Data.Conjoint;
using SSI.Windows.Application;



namespace SSI.Windows.Simulation.Conjoint
{
	internal class ScenarioViewModel : ViewModelBase
	{
		public static readonly String LabelColumnKey = "OPTIONLABEL";

		public ScenarioViewModel ()
		{
			this.AttributeInfo = AttributeTableModel.CreateAttributeTable();
			Random rand = new Random(1701);

			BindableDynamicDictionary template = new BindableDynamicDictionary();
			template[LabelColumnKey] = String.Empty;
			for (Int32 a = 0; a < this.AttributeInfo.AttributeCount; ++a)
				template[this.AttributeInfo.GetAttributeLabel(a)] = String.Empty;

			DynamicDictionaryCollection options = new DynamicDictionaryCollection()
			{
				ItemTemplate = template
			};

			for (Int32 o = 0; o < 3; ++o)
			{
				BindableDynamicDictionary option = new BindableDynamicDictionary();
				option[LabelColumnKey] = String.Format("Option{0}", o + 1);
				for (Int32 a = 0; a < this.AttributeInfo.AttributeCount; ++a)
					option[this.AttributeInfo.GetAttributeLabel(a)] = this.AttributeInfo.GetAttributeLevelLabel(a, rand.Next(this.AttributeInfo.GetAttributeLevelCount(a)));
				options.Add(option);
			}

			this.Options = options;
		}

		public IAttributeInfo AttributeInfo { get; set; }

		#region Scenario Options Property
		private DynamicDictionaryCollection options = new DynamicDictionaryCollection();
		public DynamicDictionaryCollection Options
		{
			get
			{
				return (this.options);
			}
			set
			{
				this.options = value;
				base.RaisePropertyChanged();
			}
		}
		#endregion
	}
}